/*
 * Created by SharpDevelop.
 * User: BosanqS1
 * Date: 29/10/2006
 * Time: 14:42
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Data;
using MySql.Data.MySqlClient;

namespace LARGE_VARCHAR_EXAMPLE
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm
	{
		[STAThread]
		public static void Main(string[] args)
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(new MainForm());
		}
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
			
			UserGet();
		}
		
		private void PrepareCommand(MySqlCommand cmd)
		{
			cmd.CommandType = CommandType.StoredProcedure;
		}
		
		/// <summary>
		/// Adds a param
		/// </summary>
		/// <param name="cmd"></param>
		/// <param name="ParamName"></param>
		/// <param name="ParamType"></param>
		/// <param name="Direction"></param>
		/// <param name="ParamValue"></param>
		private void AddParam(MySqlCommand cmd, string ParamName, MySqlDbType ParamType,
			ParameterDirection Direction, object ParamValue)
		{
			cmd.Parameters.Add(ParamName, ParamType);
			cmd.Parameters[ParamName].Direction = Direction;
			cmd.Parameters[ParamName].Value = ParamValue;
		}


		/// <summary>
		/// Adds an output param
		/// </summary>
		/// <param name="cmd"></param>
		/// <param name="ParamName"></param>
		/// <param name="ParamType"></param>
		private void AddParam(MySqlCommand cmd, string ParamName, MySqlDbType ParamType)
		{
			cmd.Parameters.Add(ParamName, ParamType);
			cmd.Parameters[ParamName].Direction = ParameterDirection.Output;
		}


		/// <summary>
		/// Adds an input param
		/// </summary>
		/// <param name="cmd"></param>
		/// <param name="ParamName"></param>
		/// <param name="ParamType"></param>
		/// <param name="ParamValue"></param>
		private void AddParam(MySqlCommand cmd, string ParamName, MySqlDbType ParamType,
			object ParamValue)
		{
			cmd.Parameters.Add(ParamName, ParamType);
			cmd.Parameters[ParamName].Direction = ParameterDirection.Input;
			cmd.Parameters[ParamName].Value = ParamValue;
		}


		/// <summary>
		/// Adds an input param
		/// </summary>
		/// <param name="cmd"></param>
		/// <param name="ParamName"></param>
		/// <param name="ParamType"></param>
		/// <param name="TextLength"></param>
		/// <param name="ParamValue"></param>
		private void AddParam(MySqlCommand cmd, string ParamName, MySqlDbType ParamType,
			int TextLength, object ParamValue)
		{
			string val = (string)ParamValue;

            if (val != null && val.Length > TextLength) 
			{
				throw new Exception("Text Exceeds permitted Length");
			}

			cmd.Parameters.Add(ParamName, ParamType);
			cmd.Parameters[ParamName].Size = TextLength;
			cmd.Parameters[ParamName].Direction = ParameterDirection.Input;
			cmd.Parameters[ParamName].Value = ParamValue;
		}
		
		public void UserGet()
		{
			checkBox1.Checked = false;
			string _ConnString = "Server=127.0.0.1;Port=3306;Database=large_varchar_example;Uid=DNFDB_USER;Pwd=h6tr3sc7;Pooling=true;connect timeout=600;";
			MySqlConnection db = new MySqlConnection(_ConnString);
			db.Open();
						
			MySqlTransaction tran = db.BeginTransaction(IsolationLevel.RepeatableRead);
			
			string SQL = "LARGE_VARCHAR_EXAMPLE";
			MySqlCommand cmd = new MySqlCommand(SQL, db, tran);
			
			PrepareCommand(cmd);
			
			AddParam(cmd, "?opBOARDID", MySqlDbType.Int64);
			AddParam(cmd, "?opID", MySqlDbType.Int64);
			AddParam(cmd, "?opUSERNAME", MySqlDbType.VarChar);
			AddParam(cmd, "?opPWORD", MySqlDbType.VarChar);
			AddParam(cmd, "?opEMAIL", MySqlDbType.VarChar);
			AddParam(cmd, "?opUSER_ACTIVE", MySqlDbType.VarChar);
			AddParam(cmd, "?opTITLE", MySqlDbType.VarChar);
			AddParam(cmd, "?opREALNAME", MySqlDbType.VarChar);
			AddParam(cmd, "?opDOB", MySqlDbType.Date);
			AddParam(cmd, "?opURL", MySqlDbType.VarChar);
			AddParam(cmd, "?opAVATAR", MySqlDbType.VarChar);
			AddParam(cmd, "?opLOCATION", MySqlDbType.VarChar);
			AddParam(cmd, "?opSIGNATURE", MySqlDbType.VarChar);
			AddParam(cmd, "?opSHOW_SIG", MySqlDbType.VarChar);
			AddParam(cmd, "?opLANG", MySqlDbType.VarChar);
			AddParam(cmd, "?opSTYLE", MySqlDbType.VarChar);
			AddParam(cmd, "?opNUM_POSTS", MySqlDbType.Int32);
			AddParam(cmd, "?opNUM_TOPICS", MySqlDbType.Int32);
			AddParam(cmd, "?opLAST_POST", MySqlDbType.Timestamp);
			AddParam(cmd, "?opDATE_REGISTERED", MySqlDbType.Timestamp);
			AddParam(cmd, "?opREGISTRATION_IP", MySqlDbType.VarChar);
			AddParam(cmd, "?opLAST_VISIT", MySqlDbType.Timestamp);
			AddParam(cmd, "?opADMIN_NOTES", MySqlDbType.VarChar);
			AddParam(cmd, "?opRANK", MySqlDbType.VarChar);
			AddParam(cmd, "?opHIDE_ONLINE_STATUS", MySqlDbType.VarChar);
			
			MySqlDataReader rdr = cmd.ExecuteReader();
			
							
			db.Close();
			
			checkBox1.Checked = true;
			
		}
	}
}
